
#pragma once

#include <LibJS/Runtime/Object.h>

namespace Web::Bindings {

class HTMLDialogElementPrototype : public JS::Object {
    JS_OBJECT(HTMLDialogElementPrototype, JS::Object);
    GC_DECLARE_ALLOCATOR(HTMLDialogElementPrototype);
public:
    explicit HTMLDialogElementPrototype(JS::Realm&);
    virtual void initialize(JS::Realm&) override;
    virtual ~HTMLDialogElementPrototype() override;
private:

    JS_DECLARE_NATIVE_FUNCTION(show);
        
    JS_DECLARE_NATIVE_FUNCTION(show_modal);
        
    JS_DECLARE_NATIVE_FUNCTION(close);
        
    JS_DECLARE_NATIVE_FUNCTION(request_close);
        
    JS_DECLARE_NATIVE_FUNCTION(open_getter);

    JS_DECLARE_NATIVE_FUNCTION(open_setter);

    JS_DECLARE_NATIVE_FUNCTION(return_value_getter);

    JS_DECLARE_NATIVE_FUNCTION(return_value_setter);


};


} // namespace Web::Bindings
    