
#pragma once

#include <LibJS/Runtime/Object.h>

namespace Web::Bindings {

class HTMLFrameSetElementPrototype : public JS::Object {
    JS_OBJECT(HTMLFrameSetElementPrototype, JS::Object);
    GC_DECLARE_ALLOCATOR(HTMLFrameSetElementPrototype);
public:
    explicit HTMLFrameSetElementPrototype(JS::Realm&);
    virtual void initialize(JS::Realm&) override;
    virtual ~HTMLFrameSetElementPrototype() override;
private:

    JS_DECLARE_NATIVE_FUNCTION(cols_getter);

    JS_DECLARE_NATIVE_FUNCTION(cols_setter);

    JS_DECLARE_NATIVE_FUNCTION(rows_getter);

    JS_DECLARE_NATIVE_FUNCTION(rows_setter);

    JS_DECLARE_NATIVE_FUNCTION(onafterprint_getter);

    JS_DECLARE_NATIVE_FUNCTION(onafterprint_setter);

    JS_DECLARE_NATIVE_FUNCTION(onbeforeprint_getter);

    JS_DECLARE_NATIVE_FUNCTION(onbeforeprint_setter);

    JS_DECLARE_NATIVE_FUNCTION(onbeforeunload_getter);

    JS_DECLARE_NATIVE_FUNCTION(onbeforeunload_setter);

    JS_DECLARE_NATIVE_FUNCTION(onhashchange_getter);

    JS_DECLARE_NATIVE_FUNCTION(onhashchange_setter);

    JS_DECLARE_NATIVE_FUNCTION(onlanguagechange_getter);

    JS_DECLARE_NATIVE_FUNCTION(onlanguagechange_setter);

    JS_DECLARE_NATIVE_FUNCTION(onmessage_getter);

    JS_DECLARE_NATIVE_FUNCTION(onmessage_setter);

    JS_DECLARE_NATIVE_FUNCTION(onmessageerror_getter);

    JS_DECLARE_NATIVE_FUNCTION(onmessageerror_setter);

    JS_DECLARE_NATIVE_FUNCTION(onoffline_getter);

    JS_DECLARE_NATIVE_FUNCTION(onoffline_setter);

    JS_DECLARE_NATIVE_FUNCTION(ononline_getter);

    JS_DECLARE_NATIVE_FUNCTION(ononline_setter);

    JS_DECLARE_NATIVE_FUNCTION(onpagehide_getter);

    JS_DECLARE_NATIVE_FUNCTION(onpagehide_setter);

    JS_DECLARE_NATIVE_FUNCTION(onpagereveal_getter);

    JS_DECLARE_NATIVE_FUNCTION(onpagereveal_setter);

    JS_DECLARE_NATIVE_FUNCTION(onpageshow_getter);

    JS_DECLARE_NATIVE_FUNCTION(onpageshow_setter);

    JS_DECLARE_NATIVE_FUNCTION(onpageswap_getter);

    JS_DECLARE_NATIVE_FUNCTION(onpageswap_setter);

    JS_DECLARE_NATIVE_FUNCTION(onpopstate_getter);

    JS_DECLARE_NATIVE_FUNCTION(onpopstate_setter);

    JS_DECLARE_NATIVE_FUNCTION(onrejectionhandled_getter);

    JS_DECLARE_NATIVE_FUNCTION(onrejectionhandled_setter);

    JS_DECLARE_NATIVE_FUNCTION(onstorage_getter);

    JS_DECLARE_NATIVE_FUNCTION(onstorage_setter);

    JS_DECLARE_NATIVE_FUNCTION(onunhandledrejection_getter);

    JS_DECLARE_NATIVE_FUNCTION(onunhandledrejection_setter);

    JS_DECLARE_NATIVE_FUNCTION(onunload_getter);

    JS_DECLARE_NATIVE_FUNCTION(onunload_setter);


};


} // namespace Web::Bindings
    