
#pragma once

#include <LibJS/Runtime/Object.h>

namespace Web::Bindings {

class HTMLLIElementPrototype : public JS::Object {
    JS_OBJECT(HTMLLIElementPrototype, JS::Object);
    GC_DECLARE_ALLOCATOR(HTMLLIElementPrototype);
public:
    explicit HTMLLIElementPrototype(JS::Realm&);
    virtual void initialize(JS::Realm&) override;
    virtual ~HTMLLIElementPrototype() override;
private:

    JS_DECLARE_NATIVE_FUNCTION(value_getter);

    JS_DECLARE_NATIVE_FUNCTION(value_setter);

    JS_DECLARE_NATIVE_FUNCTION(type_getter);

    JS_DECLARE_NATIVE_FUNCTION(type_setter);


};


} // namespace Web::Bindings
    