
#pragma once

#include <LibJS/Runtime/Object.h>

namespace Web::Bindings {

class IDBCursorPrototype : public JS::Object {
    JS_OBJECT(IDBCursorPrototype, JS::Object);
    GC_DECLARE_ALLOCATOR(IDBCursorPrototype);
public:
    explicit IDBCursorPrototype(JS::Realm&);
    virtual void initialize(JS::Realm&) override;
    virtual ~IDBCursorPrototype() override;
private:


};


enum class IDBCursorDirection {

    Next,

    Nextunique,

    Prev,

    Prevunique,

};

inline String idl_enum_to_string(IDBCursorDirection value)
{
    switch (value) {

    case IDBCursorDirection::Next:
        return "next"_string;

    case IDBCursorDirection::Nextunique:
        return "nextunique"_string;

    case IDBCursorDirection::Prev:
        return "prev"_string;

    case IDBCursorDirection::Prevunique:
        return "prevunique"_string;

    }
    VERIFY_NOT_REACHED();
}

} // namespace Web::Bindings
    