
#pragma once

#include <LibJS/Runtime/Object.h>

namespace Web::Bindings {

class InspectorPrototype : public JS::Object {
    JS_OBJECT(InspectorPrototype, JS::Object);
    GC_DECLARE_ALLOCATOR(InspectorPrototype);
public:
    explicit InspectorPrototype(JS::Realm&);
    virtual void initialize(JS::Realm&) override;
    virtual ~InspectorPrototype() override;
private:

    JS_DECLARE_NATIVE_FUNCTION(add_dom_node_attributes);
        
    JS_DECLARE_NATIVE_FUNCTION(inspect_dom_node);
        
    JS_DECLARE_NATIVE_FUNCTION(execute_console_script);
        
    JS_DECLARE_NATIVE_FUNCTION(export_inspector_html);
        
    JS_DECLARE_NATIVE_FUNCTION(request_dom_tree_context_menu);
        
    JS_DECLARE_NATIVE_FUNCTION(request_cookie_context_menu);
        
    JS_DECLARE_NATIVE_FUNCTION(request_style_sheet_source);
        
    JS_DECLARE_NATIVE_FUNCTION(set_dom_node_text);
        
    JS_DECLARE_NATIVE_FUNCTION(replace_dom_node_attribute);
        
    JS_DECLARE_NATIVE_FUNCTION(inspector_loaded);
        
    JS_DECLARE_NATIVE_FUNCTION(set_dom_node_tag);
        

};


} // namespace Web::Bindings
    