
#pragma once

#include <LibJS/Runtime/Object.h>

namespace Web::Bindings {

class InternalsPrototype : public JS::Object {
    JS_OBJECT(InternalsPrototype, JS::Object);
    GC_DECLARE_ALLOCATOR(InternalsPrototype);
public:
    explicit InternalsPrototype(JS::Realm&);
    virtual void initialize(JS::Realm&) override;
    virtual ~InternalsPrototype() override;
private:

    JS_DECLARE_NATIVE_FUNCTION(move_pointer_to);
        
    JS_DECLARE_NATIVE_FUNCTION(click);
        
    JS_DECLARE_NATIVE_FUNCTION(send_text);
        
    JS_DECLARE_NATIVE_FUNCTION(get_echo_server_port);
        
    JS_DECLARE_NATIVE_FUNCTION(simulate_drag_start);
        
    JS_DECLARE_NATIVE_FUNCTION(doubleclick);
        
    JS_DECLARE_NATIVE_FUNCTION(commit_text);
        
    JS_DECLARE_NATIVE_FUNCTION(create_internal_animation_timeline);
        
    JS_DECLARE_NATIVE_FUNCTION(simulate_drag_move);
        
    JS_DECLARE_NATIVE_FUNCTION(gc);
        
    JS_DECLARE_NATIVE_FUNCTION(hit_test);
        
    JS_DECLARE_NATIVE_FUNCTION(wheel);
        
    JS_DECLARE_NATIVE_FUNCTION(expire_cookies_with_time_offset);
        
    JS_DECLARE_NATIVE_FUNCTION(signal_text_test_is_done);
        
    JS_DECLARE_NATIVE_FUNCTION(simulate_drop);
        
    JS_DECLARE_NATIVE_FUNCTION(set_browser_zoom);
        
    JS_DECLARE_NATIVE_FUNCTION(spoof_current_url);
        
    JS_DECLARE_NATIVE_FUNCTION(mouse_down);
        
    JS_DECLARE_NATIVE_FUNCTION(dispatch_user_activated_event);
        
    JS_DECLARE_NATIVE_FUNCTION(get_computed_label);
        
    JS_DECLARE_NATIVE_FUNCTION(middle_click);
        
    JS_DECLARE_NATIVE_FUNCTION(set_test_timeout);
        
    JS_DECLARE_NATIVE_FUNCTION(send_key);
        
    JS_DECLARE_NATIVE_FUNCTION(enable_cookies_on_file_domains);
        
    JS_DECLARE_NATIVE_FUNCTION(get_computed_role);
        
    JS_DECLARE_NATIVE_FUNCTION(headless_getter);


};


} // namespace Web::Bindings
    