
#pragma once

#include <AK/String.h>
#include <LibWeb/Forward.h>

namespace Web::Bindings {

class GeneratedCSSStyleProperties {
public:

    WebIDL::ExceptionOr<void> set_webkit_align_content(StringView value);
    String webkit_align_content() const;

    WebIDL::ExceptionOr<void> set_webkit_align_items(StringView value);
    String webkit_align_items() const;

    WebIDL::ExceptionOr<void> set_webkit_align_self(StringView value);
    String webkit_align_self() const;

    WebIDL::ExceptionOr<void> set_webkit_animation(StringView value);
    String webkit_animation() const;

    WebIDL::ExceptionOr<void> set_webkit_animation_delay(StringView value);
    String webkit_animation_delay() const;

    WebIDL::ExceptionOr<void> set_webkit_animation_direction(StringView value);
    String webkit_animation_direction() const;

    WebIDL::ExceptionOr<void> set_webkit_animation_duration(StringView value);
    String webkit_animation_duration() const;

    WebIDL::ExceptionOr<void> set_webkit_animation_fill_mode(StringView value);
    String webkit_animation_fill_mode() const;

    WebIDL::ExceptionOr<void> set_webkit_animation_iteration_count(StringView value);
    String webkit_animation_iteration_count() const;

    WebIDL::ExceptionOr<void> set_webkit_animation_name(StringView value);
    String webkit_animation_name() const;

    WebIDL::ExceptionOr<void> set_webkit_animation_play_state(StringView value);
    String webkit_animation_play_state() const;

    WebIDL::ExceptionOr<void> set_webkit_animation_timing_function(StringView value);
    String webkit_animation_timing_function() const;

    WebIDL::ExceptionOr<void> set_webkit_appearance(StringView value);
    String webkit_appearance() const;

    WebIDL::ExceptionOr<void> set_webkit_background_clip(StringView value);
    String webkit_background_clip() const;

    WebIDL::ExceptionOr<void> set_webkit_background_origin(StringView value);
    String webkit_background_origin() const;

    WebIDL::ExceptionOr<void> set_webkit_background_size(StringView value);
    String webkit_background_size() const;

    WebIDL::ExceptionOr<void> set_webkit_border_bottom_left_radius(StringView value);
    String webkit_border_bottom_left_radius() const;

    WebIDL::ExceptionOr<void> set_webkit_border_bottom_right_radius(StringView value);
    String webkit_border_bottom_right_radius() const;

    WebIDL::ExceptionOr<void> set_webkit_border_radius(StringView value);
    String webkit_border_radius() const;

    WebIDL::ExceptionOr<void> set_webkit_border_top_left_radius(StringView value);
    String webkit_border_top_left_radius() const;

    WebIDL::ExceptionOr<void> set_webkit_border_top_right_radius(StringView value);
    String webkit_border_top_right_radius() const;

    WebIDL::ExceptionOr<void> set_webkit_box_shadow(StringView value);
    String webkit_box_shadow() const;

    WebIDL::ExceptionOr<void> set_webkit_box_sizing(StringView value);
    String webkit_box_sizing() const;

    WebIDL::ExceptionOr<void> set_webkit_flex(StringView value);
    String webkit_flex() const;

    WebIDL::ExceptionOr<void> set_webkit_flex_basis(StringView value);
    String webkit_flex_basis() const;

    WebIDL::ExceptionOr<void> set_webkit_flex_direction(StringView value);
    String webkit_flex_direction() const;

    WebIDL::ExceptionOr<void> set_webkit_flex_flow(StringView value);
    String webkit_flex_flow() const;

    WebIDL::ExceptionOr<void> set_webkit_flex_grow(StringView value);
    String webkit_flex_grow() const;

    WebIDL::ExceptionOr<void> set_webkit_flex_shrink(StringView value);
    String webkit_flex_shrink() const;

    WebIDL::ExceptionOr<void> set_webkit_flex_wrap(StringView value);
    String webkit_flex_wrap() const;

    WebIDL::ExceptionOr<void> set_webkit_justify_content(StringView value);
    String webkit_justify_content() const;

    WebIDL::ExceptionOr<void> set_webkit_mask(StringView value);
    String webkit_mask() const;

    WebIDL::ExceptionOr<void> set_webkit_mask_image(StringView value);
    String webkit_mask_image() const;

    WebIDL::ExceptionOr<void> set_webkit_order(StringView value);
    String webkit_order() const;

    WebIDL::ExceptionOr<void> set_webkit_text_fill_color(StringView value);
    String webkit_text_fill_color() const;

    WebIDL::ExceptionOr<void> set_webkit_transform(StringView value);
    String webkit_transform() const;

    WebIDL::ExceptionOr<void> set_webkit_transform_origin(StringView value);
    String webkit_transform_origin() const;

    WebIDL::ExceptionOr<void> set_webkit_transition(StringView value);
    String webkit_transition() const;

    WebIDL::ExceptionOr<void> set_webkit_transition_delay(StringView value);
    String webkit_transition_delay() const;

    WebIDL::ExceptionOr<void> set_webkit_transition_duration(StringView value);
    String webkit_transition_duration() const;

    WebIDL::ExceptionOr<void> set_webkit_transition_property(StringView value);
    String webkit_transition_property() const;

    WebIDL::ExceptionOr<void> set_webkit_transition_timing_function(StringView value);
    String webkit_transition_timing_function() const;

    WebIDL::ExceptionOr<void> set_webkit_user_select(StringView value);
    String webkit_user_select() const;

    WebIDL::ExceptionOr<void> set_accent_color(StringView value);
    String accent_color() const;

    WebIDL::ExceptionOr<void> set_align_content(StringView value);
    String align_content() const;

    WebIDL::ExceptionOr<void> set_align_items(StringView value);
    String align_items() const;

    WebIDL::ExceptionOr<void> set_align_self(StringView value);
    String align_self() const;

    WebIDL::ExceptionOr<void> set_animation(StringView value);
    String animation() const;

    WebIDL::ExceptionOr<void> set_animation_delay(StringView value);
    String animation_delay() const;

    WebIDL::ExceptionOr<void> set_animation_direction(StringView value);
    String animation_direction() const;

    WebIDL::ExceptionOr<void> set_animation_duration(StringView value);
    String animation_duration() const;

    WebIDL::ExceptionOr<void> set_animation_fill_mode(StringView value);
    String animation_fill_mode() const;

    WebIDL::ExceptionOr<void> set_animation_iteration_count(StringView value);
    String animation_iteration_count() const;

    WebIDL::ExceptionOr<void> set_animation_name(StringView value);
    String animation_name() const;

    WebIDL::ExceptionOr<void> set_animation_play_state(StringView value);
    String animation_play_state() const;

    WebIDL::ExceptionOr<void> set_animation_timing_function(StringView value);
    String animation_timing_function() const;

    WebIDL::ExceptionOr<void> set_appearance(StringView value);
    String appearance() const;

    WebIDL::ExceptionOr<void> set_aspect_ratio(StringView value);
    String aspect_ratio() const;

    WebIDL::ExceptionOr<void> set_backdrop_filter(StringView value);
    String backdrop_filter() const;

    WebIDL::ExceptionOr<void> set_background(StringView value);
    String background() const;

    WebIDL::ExceptionOr<void> set_background_attachment(StringView value);
    String background_attachment() const;

    WebIDL::ExceptionOr<void> set_background_clip(StringView value);
    String background_clip() const;

    WebIDL::ExceptionOr<void> set_background_color(StringView value);
    String background_color() const;

    WebIDL::ExceptionOr<void> set_background_image(StringView value);
    String background_image() const;

    WebIDL::ExceptionOr<void> set_background_origin(StringView value);
    String background_origin() const;

    WebIDL::ExceptionOr<void> set_background_position(StringView value);
    String background_position() const;

    WebIDL::ExceptionOr<void> set_background_position_x(StringView value);
    String background_position_x() const;

    WebIDL::ExceptionOr<void> set_background_position_y(StringView value);
    String background_position_y() const;

    WebIDL::ExceptionOr<void> set_background_repeat(StringView value);
    String background_repeat() const;

    WebIDL::ExceptionOr<void> set_background_size(StringView value);
    String background_size() const;

    WebIDL::ExceptionOr<void> set_block_size(StringView value);
    String block_size() const;

    WebIDL::ExceptionOr<void> set_border(StringView value);
    String border() const;

    WebIDL::ExceptionOr<void> set_border_bottom(StringView value);
    String border_bottom() const;

    WebIDL::ExceptionOr<void> set_border_bottom_color(StringView value);
    String border_bottom_color() const;

    WebIDL::ExceptionOr<void> set_border_bottom_left_radius(StringView value);
    String border_bottom_left_radius() const;

    WebIDL::ExceptionOr<void> set_border_bottom_right_radius(StringView value);
    String border_bottom_right_radius() const;

    WebIDL::ExceptionOr<void> set_border_bottom_style(StringView value);
    String border_bottom_style() const;

    WebIDL::ExceptionOr<void> set_border_bottom_width(StringView value);
    String border_bottom_width() const;

    WebIDL::ExceptionOr<void> set_border_collapse(StringView value);
    String border_collapse() const;

    WebIDL::ExceptionOr<void> set_border_color(StringView value);
    String border_color() const;

    WebIDL::ExceptionOr<void> set_border_left(StringView value);
    String border_left() const;

    WebIDL::ExceptionOr<void> set_border_left_color(StringView value);
    String border_left_color() const;

    WebIDL::ExceptionOr<void> set_border_left_style(StringView value);
    String border_left_style() const;

    WebIDL::ExceptionOr<void> set_border_left_width(StringView value);
    String border_left_width() const;

    WebIDL::ExceptionOr<void> set_border_radius(StringView value);
    String border_radius() const;

    WebIDL::ExceptionOr<void> set_border_right(StringView value);
    String border_right() const;

    WebIDL::ExceptionOr<void> set_border_right_color(StringView value);
    String border_right_color() const;

    WebIDL::ExceptionOr<void> set_border_right_style(StringView value);
    String border_right_style() const;

    WebIDL::ExceptionOr<void> set_border_right_width(StringView value);
    String border_right_width() const;

    WebIDL::ExceptionOr<void> set_border_spacing(StringView value);
    String border_spacing() const;

    WebIDL::ExceptionOr<void> set_border_style(StringView value);
    String border_style() const;

    WebIDL::ExceptionOr<void> set_border_top(StringView value);
    String border_top() const;

    WebIDL::ExceptionOr<void> set_border_top_color(StringView value);
    String border_top_color() const;

    WebIDL::ExceptionOr<void> set_border_top_left_radius(StringView value);
    String border_top_left_radius() const;

    WebIDL::ExceptionOr<void> set_border_top_right_radius(StringView value);
    String border_top_right_radius() const;

    WebIDL::ExceptionOr<void> set_border_top_style(StringView value);
    String border_top_style() const;

    WebIDL::ExceptionOr<void> set_border_top_width(StringView value);
    String border_top_width() const;

    WebIDL::ExceptionOr<void> set_border_width(StringView value);
    String border_width() const;

    WebIDL::ExceptionOr<void> set_bottom(StringView value);
    String bottom() const;

    WebIDL::ExceptionOr<void> set_box_shadow(StringView value);
    String box_shadow() const;

    WebIDL::ExceptionOr<void> set_box_sizing(StringView value);
    String box_sizing() const;

    WebIDL::ExceptionOr<void> set_caption_side(StringView value);
    String caption_side() const;

    WebIDL::ExceptionOr<void> set_clear(StringView value);
    String clear() const;

    WebIDL::ExceptionOr<void> set_clip(StringView value);
    String clip() const;

    WebIDL::ExceptionOr<void> set_clip_path(StringView value);
    String clip_path() const;

    WebIDL::ExceptionOr<void> set_clip_rule(StringView value);
    String clip_rule() const;

    WebIDL::ExceptionOr<void> set_color(StringView value);
    String color() const;

    WebIDL::ExceptionOr<void> set_color_scheme(StringView value);
    String color_scheme() const;

    WebIDL::ExceptionOr<void> set_column_count(StringView value);
    String column_count() const;

    WebIDL::ExceptionOr<void> set_column_gap(StringView value);
    String column_gap() const;

    WebIDL::ExceptionOr<void> set_column_span(StringView value);
    String column_span() const;

    WebIDL::ExceptionOr<void> set_column_width(StringView value);
    String column_width() const;

    WebIDL::ExceptionOr<void> set_columns(StringView value);
    String columns() const;

    WebIDL::ExceptionOr<void> set_contain(StringView value);
    String contain() const;

    WebIDL::ExceptionOr<void> set_content(StringView value);
    String content() const;

    WebIDL::ExceptionOr<void> set_content_visibility(StringView value);
    String content_visibility() const;

    WebIDL::ExceptionOr<void> set_counter_increment(StringView value);
    String counter_increment() const;

    WebIDL::ExceptionOr<void> set_counter_reset(StringView value);
    String counter_reset() const;

    WebIDL::ExceptionOr<void> set_counter_set(StringView value);
    String counter_set() const;

    WebIDL::ExceptionOr<void> set_cursor(StringView value);
    String cursor() const;

    WebIDL::ExceptionOr<void> set_cx(StringView value);
    String cx() const;

    WebIDL::ExceptionOr<void> set_cy(StringView value);
    String cy() const;

    WebIDL::ExceptionOr<void> set_direction(StringView value);
    String direction() const;

    WebIDL::ExceptionOr<void> set_display(StringView value);
    String display() const;

    WebIDL::ExceptionOr<void> set_fill(StringView value);
    String fill() const;

    WebIDL::ExceptionOr<void> set_fill_opacity(StringView value);
    String fill_opacity() const;

    WebIDL::ExceptionOr<void> set_fill_rule(StringView value);
    String fill_rule() const;

    WebIDL::ExceptionOr<void> set_filter(StringView value);
    String filter() const;

    WebIDL::ExceptionOr<void> set_flex(StringView value);
    String flex() const;

    WebIDL::ExceptionOr<void> set_flex_basis(StringView value);
    String flex_basis() const;

    WebIDL::ExceptionOr<void> set_flex_direction(StringView value);
    String flex_direction() const;

    WebIDL::ExceptionOr<void> set_flex_flow(StringView value);
    String flex_flow() const;

    WebIDL::ExceptionOr<void> set_flex_grow(StringView value);
    String flex_grow() const;

    WebIDL::ExceptionOr<void> set_flex_shrink(StringView value);
    String flex_shrink() const;

    WebIDL::ExceptionOr<void> set_flex_wrap(StringView value);
    String flex_wrap() const;

    WebIDL::ExceptionOr<void> set_float_(StringView value);
    String float_() const;

    WebIDL::ExceptionOr<void> set_font(StringView value);
    String font() const;

    WebIDL::ExceptionOr<void> set_font_family(StringView value);
    String font_family() const;

    WebIDL::ExceptionOr<void> set_font_feature_settings(StringView value);
    String font_feature_settings() const;

    WebIDL::ExceptionOr<void> set_font_language_override(StringView value);
    String font_language_override() const;

    WebIDL::ExceptionOr<void> set_font_size(StringView value);
    String font_size() const;

    WebIDL::ExceptionOr<void> set_font_stretch(StringView value);
    String font_stretch() const;

    WebIDL::ExceptionOr<void> set_font_style(StringView value);
    String font_style() const;

    WebIDL::ExceptionOr<void> set_font_variant(StringView value);
    String font_variant() const;

    WebIDL::ExceptionOr<void> set_font_variant_alternates(StringView value);
    String font_variant_alternates() const;

    WebIDL::ExceptionOr<void> set_font_variant_caps(StringView value);
    String font_variant_caps() const;

    WebIDL::ExceptionOr<void> set_font_variant_east_asian(StringView value);
    String font_variant_east_asian() const;

    WebIDL::ExceptionOr<void> set_font_variant_emoji(StringView value);
    String font_variant_emoji() const;

    WebIDL::ExceptionOr<void> set_font_variant_ligatures(StringView value);
    String font_variant_ligatures() const;

    WebIDL::ExceptionOr<void> set_font_variant_numeric(StringView value);
    String font_variant_numeric() const;

    WebIDL::ExceptionOr<void> set_font_variant_position(StringView value);
    String font_variant_position() const;

    WebIDL::ExceptionOr<void> set_font_variation_settings(StringView value);
    String font_variation_settings() const;

    WebIDL::ExceptionOr<void> set_font_weight(StringView value);
    String font_weight() const;

    WebIDL::ExceptionOr<void> set_font_width(StringView value);
    String font_width() const;

    WebIDL::ExceptionOr<void> set_gap(StringView value);
    String gap() const;

    WebIDL::ExceptionOr<void> set_grid(StringView value);
    String grid() const;

    WebIDL::ExceptionOr<void> set_grid_area(StringView value);
    String grid_area() const;

    WebIDL::ExceptionOr<void> set_grid_auto_columns(StringView value);
    String grid_auto_columns() const;

    WebIDL::ExceptionOr<void> set_grid_auto_flow(StringView value);
    String grid_auto_flow() const;

    WebIDL::ExceptionOr<void> set_grid_auto_rows(StringView value);
    String grid_auto_rows() const;

    WebIDL::ExceptionOr<void> set_grid_column(StringView value);
    String grid_column() const;

    WebIDL::ExceptionOr<void> set_grid_column_end(StringView value);
    String grid_column_end() const;

    WebIDL::ExceptionOr<void> set_grid_column_gap(StringView value);
    String grid_column_gap() const;

    WebIDL::ExceptionOr<void> set_grid_column_start(StringView value);
    String grid_column_start() const;

    WebIDL::ExceptionOr<void> set_grid_gap(StringView value);
    String grid_gap() const;

    WebIDL::ExceptionOr<void> set_grid_row(StringView value);
    String grid_row() const;

    WebIDL::ExceptionOr<void> set_grid_row_end(StringView value);
    String grid_row_end() const;

    WebIDL::ExceptionOr<void> set_grid_row_gap(StringView value);
    String grid_row_gap() const;

    WebIDL::ExceptionOr<void> set_grid_row_start(StringView value);
    String grid_row_start() const;

    WebIDL::ExceptionOr<void> set_grid_template(StringView value);
    String grid_template() const;

    WebIDL::ExceptionOr<void> set_grid_template_areas(StringView value);
    String grid_template_areas() const;

    WebIDL::ExceptionOr<void> set_grid_template_columns(StringView value);
    String grid_template_columns() const;

    WebIDL::ExceptionOr<void> set_grid_template_rows(StringView value);
    String grid_template_rows() const;

    WebIDL::ExceptionOr<void> set_height(StringView value);
    String height() const;

    WebIDL::ExceptionOr<void> set_image_rendering(StringView value);
    String image_rendering() const;

    WebIDL::ExceptionOr<void> set_inline_size(StringView value);
    String inline_size() const;

    WebIDL::ExceptionOr<void> set_inset(StringView value);
    String inset() const;

    WebIDL::ExceptionOr<void> set_inset_block(StringView value);
    String inset_block() const;

    WebIDL::ExceptionOr<void> set_inset_block_end(StringView value);
    String inset_block_end() const;

    WebIDL::ExceptionOr<void> set_inset_block_start(StringView value);
    String inset_block_start() const;

    WebIDL::ExceptionOr<void> set_inset_inline(StringView value);
    String inset_inline() const;

    WebIDL::ExceptionOr<void> set_inset_inline_end(StringView value);
    String inset_inline_end() const;

    WebIDL::ExceptionOr<void> set_inset_inline_start(StringView value);
    String inset_inline_start() const;

    WebIDL::ExceptionOr<void> set_isolation(StringView value);
    String isolation() const;

    WebIDL::ExceptionOr<void> set_justify_content(StringView value);
    String justify_content() const;

    WebIDL::ExceptionOr<void> set_justify_items(StringView value);
    String justify_items() const;

    WebIDL::ExceptionOr<void> set_justify_self(StringView value);
    String justify_self() const;

    WebIDL::ExceptionOr<void> set_left(StringView value);
    String left() const;

    WebIDL::ExceptionOr<void> set_letter_spacing(StringView value);
    String letter_spacing() const;

    WebIDL::ExceptionOr<void> set_line_height(StringView value);
    String line_height() const;

    WebIDL::ExceptionOr<void> set_list_style(StringView value);
    String list_style() const;

    WebIDL::ExceptionOr<void> set_list_style_image(StringView value);
    String list_style_image() const;

    WebIDL::ExceptionOr<void> set_list_style_position(StringView value);
    String list_style_position() const;

    WebIDL::ExceptionOr<void> set_list_style_type(StringView value);
    String list_style_type() const;

    WebIDL::ExceptionOr<void> set_margin(StringView value);
    String margin() const;

    WebIDL::ExceptionOr<void> set_margin_block(StringView value);
    String margin_block() const;

    WebIDL::ExceptionOr<void> set_margin_block_end(StringView value);
    String margin_block_end() const;

    WebIDL::ExceptionOr<void> set_margin_block_start(StringView value);
    String margin_block_start() const;

    WebIDL::ExceptionOr<void> set_margin_bottom(StringView value);
    String margin_bottom() const;

    WebIDL::ExceptionOr<void> set_margin_inline(StringView value);
    String margin_inline() const;

    WebIDL::ExceptionOr<void> set_margin_inline_end(StringView value);
    String margin_inline_end() const;

    WebIDL::ExceptionOr<void> set_margin_inline_start(StringView value);
    String margin_inline_start() const;

    WebIDL::ExceptionOr<void> set_margin_left(StringView value);
    String margin_left() const;

    WebIDL::ExceptionOr<void> set_margin_right(StringView value);
    String margin_right() const;

    WebIDL::ExceptionOr<void> set_margin_top(StringView value);
    String margin_top() const;

    WebIDL::ExceptionOr<void> set_mask(StringView value);
    String mask() const;

    WebIDL::ExceptionOr<void> set_mask_image(StringView value);
    String mask_image() const;

    WebIDL::ExceptionOr<void> set_mask_type(StringView value);
    String mask_type() const;

    WebIDL::ExceptionOr<void> set_math_depth(StringView value);
    String math_depth() const;

    WebIDL::ExceptionOr<void> set_math_shift(StringView value);
    String math_shift() const;

    WebIDL::ExceptionOr<void> set_math_style(StringView value);
    String math_style() const;

    WebIDL::ExceptionOr<void> set_max_block_size(StringView value);
    String max_block_size() const;

    WebIDL::ExceptionOr<void> set_max_height(StringView value);
    String max_height() const;

    WebIDL::ExceptionOr<void> set_max_inline_size(StringView value);
    String max_inline_size() const;

    WebIDL::ExceptionOr<void> set_max_width(StringView value);
    String max_width() const;

    WebIDL::ExceptionOr<void> set_min_block_size(StringView value);
    String min_block_size() const;

    WebIDL::ExceptionOr<void> set_min_height(StringView value);
    String min_height() const;

    WebIDL::ExceptionOr<void> set_min_inline_size(StringView value);
    String min_inline_size() const;

    WebIDL::ExceptionOr<void> set_min_width(StringView value);
    String min_width() const;

    WebIDL::ExceptionOr<void> set_mix_blend_mode(StringView value);
    String mix_blend_mode() const;

    WebIDL::ExceptionOr<void> set_object_fit(StringView value);
    String object_fit() const;

    WebIDL::ExceptionOr<void> set_object_position(StringView value);
    String object_position() const;

    WebIDL::ExceptionOr<void> set_opacity(StringView value);
    String opacity() const;

    WebIDL::ExceptionOr<void> set_order(StringView value);
    String order() const;

    WebIDL::ExceptionOr<void> set_outline(StringView value);
    String outline() const;

    WebIDL::ExceptionOr<void> set_outline_color(StringView value);
    String outline_color() const;

    WebIDL::ExceptionOr<void> set_outline_offset(StringView value);
    String outline_offset() const;

    WebIDL::ExceptionOr<void> set_outline_style(StringView value);
    String outline_style() const;

    WebIDL::ExceptionOr<void> set_outline_width(StringView value);
    String outline_width() const;

    WebIDL::ExceptionOr<void> set_overflow(StringView value);
    String overflow() const;

    WebIDL::ExceptionOr<void> set_overflow_x(StringView value);
    String overflow_x() const;

    WebIDL::ExceptionOr<void> set_overflow_y(StringView value);
    String overflow_y() const;

    WebIDL::ExceptionOr<void> set_padding(StringView value);
    String padding() const;

    WebIDL::ExceptionOr<void> set_padding_block(StringView value);
    String padding_block() const;

    WebIDL::ExceptionOr<void> set_padding_block_end(StringView value);
    String padding_block_end() const;

    WebIDL::ExceptionOr<void> set_padding_block_start(StringView value);
    String padding_block_start() const;

    WebIDL::ExceptionOr<void> set_padding_bottom(StringView value);
    String padding_bottom() const;

    WebIDL::ExceptionOr<void> set_padding_inline(StringView value);
    String padding_inline() const;

    WebIDL::ExceptionOr<void> set_padding_inline_end(StringView value);
    String padding_inline_end() const;

    WebIDL::ExceptionOr<void> set_padding_inline_start(StringView value);
    String padding_inline_start() const;

    WebIDL::ExceptionOr<void> set_padding_left(StringView value);
    String padding_left() const;

    WebIDL::ExceptionOr<void> set_padding_right(StringView value);
    String padding_right() const;

    WebIDL::ExceptionOr<void> set_padding_top(StringView value);
    String padding_top() const;

    WebIDL::ExceptionOr<void> set_place_content(StringView value);
    String place_content() const;

    WebIDL::ExceptionOr<void> set_place_items(StringView value);
    String place_items() const;

    WebIDL::ExceptionOr<void> set_place_self(StringView value);
    String place_self() const;

    WebIDL::ExceptionOr<void> set_pointer_events(StringView value);
    String pointer_events() const;

    WebIDL::ExceptionOr<void> set_position(StringView value);
    String position() const;

    WebIDL::ExceptionOr<void> set_quotes(StringView value);
    String quotes() const;

    WebIDL::ExceptionOr<void> set_r(StringView value);
    String r() const;

    WebIDL::ExceptionOr<void> set_right(StringView value);
    String right() const;

    WebIDL::ExceptionOr<void> set_rotate(StringView value);
    String rotate() const;

    WebIDL::ExceptionOr<void> set_row_gap(StringView value);
    String row_gap() const;

    WebIDL::ExceptionOr<void> set_rx(StringView value);
    String rx() const;

    WebIDL::ExceptionOr<void> set_ry(StringView value);
    String ry() const;

    WebIDL::ExceptionOr<void> set_scale(StringView value);
    String scale() const;

    WebIDL::ExceptionOr<void> set_scrollbar_gutter(StringView value);
    String scrollbar_gutter() const;

    WebIDL::ExceptionOr<void> set_scrollbar_width(StringView value);
    String scrollbar_width() const;

    WebIDL::ExceptionOr<void> set_stop_color(StringView value);
    String stop_color() const;

    WebIDL::ExceptionOr<void> set_stop_opacity(StringView value);
    String stop_opacity() const;

    WebIDL::ExceptionOr<void> set_stroke(StringView value);
    String stroke() const;

    WebIDL::ExceptionOr<void> set_stroke_dasharray(StringView value);
    String stroke_dasharray() const;

    WebIDL::ExceptionOr<void> set_stroke_dashoffset(StringView value);
    String stroke_dashoffset() const;

    WebIDL::ExceptionOr<void> set_stroke_linecap(StringView value);
    String stroke_linecap() const;

    WebIDL::ExceptionOr<void> set_stroke_linejoin(StringView value);
    String stroke_linejoin() const;

    WebIDL::ExceptionOr<void> set_stroke_miterlimit(StringView value);
    String stroke_miterlimit() const;

    WebIDL::ExceptionOr<void> set_stroke_opacity(StringView value);
    String stroke_opacity() const;

    WebIDL::ExceptionOr<void> set_stroke_width(StringView value);
    String stroke_width() const;

    WebIDL::ExceptionOr<void> set_tab_size(StringView value);
    String tab_size() const;

    WebIDL::ExceptionOr<void> set_table_layout(StringView value);
    String table_layout() const;

    WebIDL::ExceptionOr<void> set_text_align(StringView value);
    String text_align() const;

    WebIDL::ExceptionOr<void> set_text_anchor(StringView value);
    String text_anchor() const;

    WebIDL::ExceptionOr<void> set_text_decoration(StringView value);
    String text_decoration() const;

    WebIDL::ExceptionOr<void> set_text_decoration_color(StringView value);
    String text_decoration_color() const;

    WebIDL::ExceptionOr<void> set_text_decoration_line(StringView value);
    String text_decoration_line() const;

    WebIDL::ExceptionOr<void> set_text_decoration_style(StringView value);
    String text_decoration_style() const;

    WebIDL::ExceptionOr<void> set_text_decoration_thickness(StringView value);
    String text_decoration_thickness() const;

    WebIDL::ExceptionOr<void> set_text_indent(StringView value);
    String text_indent() const;

    WebIDL::ExceptionOr<void> set_text_justify(StringView value);
    String text_justify() const;

    WebIDL::ExceptionOr<void> set_text_overflow(StringView value);
    String text_overflow() const;

    WebIDL::ExceptionOr<void> set_text_shadow(StringView value);
    String text_shadow() const;

    WebIDL::ExceptionOr<void> set_text_transform(StringView value);
    String text_transform() const;

    WebIDL::ExceptionOr<void> set_top(StringView value);
    String top() const;

    WebIDL::ExceptionOr<void> set_transform(StringView value);
    String transform() const;

    WebIDL::ExceptionOr<void> set_transform_box(StringView value);
    String transform_box() const;

    WebIDL::ExceptionOr<void> set_transform_origin(StringView value);
    String transform_origin() const;

    WebIDL::ExceptionOr<void> set_transition(StringView value);
    String transition() const;

    WebIDL::ExceptionOr<void> set_transition_delay(StringView value);
    String transition_delay() const;

    WebIDL::ExceptionOr<void> set_transition_duration(StringView value);
    String transition_duration() const;

    WebIDL::ExceptionOr<void> set_transition_property(StringView value);
    String transition_property() const;

    WebIDL::ExceptionOr<void> set_transition_timing_function(StringView value);
    String transition_timing_function() const;

    WebIDL::ExceptionOr<void> set_translate(StringView value);
    String translate() const;

    WebIDL::ExceptionOr<void> set_unicode_bidi(StringView value);
    String unicode_bidi() const;

    WebIDL::ExceptionOr<void> set_user_select(StringView value);
    String user_select() const;

    WebIDL::ExceptionOr<void> set_vertical_align(StringView value);
    String vertical_align() const;

    WebIDL::ExceptionOr<void> set_visibility(StringView value);
    String visibility() const;

    WebIDL::ExceptionOr<void> set_white_space(StringView value);
    String white_space() const;

    WebIDL::ExceptionOr<void> set_width(StringView value);
    String width() const;

    WebIDL::ExceptionOr<void> set_word_break(StringView value);
    String word_break() const;

    WebIDL::ExceptionOr<void> set_word_spacing(StringView value);
    String word_spacing() const;

    WebIDL::ExceptionOr<void> set_word_wrap(StringView value);
    String word_wrap() const;

    WebIDL::ExceptionOr<void> set_writing_mode(StringView value);
    String writing_mode() const;

    WebIDL::ExceptionOr<void> set_x(StringView value);
    String x() const;

    WebIDL::ExceptionOr<void> set_y(StringView value);
    String y() const;

    WebIDL::ExceptionOr<void> set_z_index(StringView value);
    String z_index() const;

protected:
    GeneratedCSSStyleProperties() = default;
    virtual ~GeneratedCSSStyleProperties() = default;

    virtual CSS::CSSStyleDeclaration& generated_style_properties_to_css_style_declaration() = 0;
    CSS::CSSStyleDeclaration const& generated_style_properties_to_css_style_declaration() const { return const_cast<GeneratedCSSStyleProperties&>(*this).generated_style_properties_to_css_style_declaration(); }
}; // class GeneratedCSSStyleProperties

} // namespace Web::Bindings
