
#pragma once

#include <AK/StringView.h>
#include <AK/Traits.h>

namespace Web::CSS {

enum class Keyword {
    Invalid,

    LibwebCenter,

    LibwebLeft,

    LibwebLink,

    LibwebPaletteActiveLink,

    LibwebPaletteActiveWindowBorder1,

    LibwebPaletteActiveWindowBorder2,

    LibwebPaletteActiveWindowTitle,

    LibwebPaletteBase,

    LibwebPaletteBaseText,

    LibwebPaletteButton,

    LibwebPaletteButtonText,

    LibwebPaletteDesktopBackground,

    LibwebPaletteFocusOutline,

    LibwebPaletteHighlightWindowBorder1,

    LibwebPaletteHighlightWindowBorder2,

    LibwebPaletteHighlightWindowTitle,

    LibwebPaletteHoverHighlight,

    LibwebPaletteInactiveSelection,

    LibwebPaletteInactiveSelectionText,

    LibwebPaletteInactiveWindowBorder1,

    LibwebPaletteInactiveWindowBorder2,

    LibwebPaletteInactiveWindowTitle,

    LibwebPaletteLink,

    LibwebPaletteMenuBase,

    LibwebPaletteMenuBaseText,

    LibwebPaletteMenuSelection,

    LibwebPaletteMenuSelectionText,

    LibwebPaletteMenuStripe,

    LibwebPaletteMovingWindowBorder1,

    LibwebPaletteMovingWindowBorder2,

    LibwebPaletteMovingWindowTitle,

    LibwebPaletteRubberBandBorder,

    LibwebPaletteRubberBandFill,

    LibwebPaletteRuler,

    LibwebPaletteRulerActiveText,

    LibwebPaletteRulerBorder,

    LibwebPaletteRulerInactiveText,

    LibwebPaletteSelection,

    LibwebPaletteSelectionText,

    LibwebPaletteSyntaxComment,

    LibwebPaletteSyntaxControlKeyword,

    LibwebPaletteSyntaxIdentifier,

    LibwebPaletteSyntaxKeyword,

    LibwebPaletteSyntaxNumber,

    LibwebPaletteSyntaxOperator,

    LibwebPaletteSyntaxPreprocessorStatement,

    LibwebPaletteSyntaxPreprocessorValue,

    LibwebPaletteSyntaxPunctuation,

    LibwebPaletteSyntaxString,

    LibwebPaletteSyntaxType,

    LibwebPaletteTextCursor,

    LibwebPaletteThreedHighlight,

    LibwebPaletteThreedShadow1,

    LibwebPaletteThreedShadow2,

    LibwebPaletteVisitedLink,

    LibwebPaletteWindow,

    LibwebPaletteWindowText,

    LibwebRight,

    Absolute,

    Accentcolor,

    Accentcolortext,

    Active,

    Activeborder,

    Activecaption,

    Activetext,

    Additive,

    Alias,

    All,

    AllPetiteCaps,

    AllScroll,

    AllSmallCaps,

    Alpha,

    Alternate,

    AlternateReverse,

    Anywhere,

    Appworkspace,

    Auto,

    AutoAdd,

    Back,

    Background,

    Backwards,

    Baseline,

    Bevel,

    BidiOverride,

    Blink,

    Block,

    Bold,

    Bolder,

    BorderBox,

    Both,

    BothEdges,

    Bottom,

    BreakAll,

    BreakWord,

    Browser,

    Butt,

    Button,

    Buttonborder,

    Buttonface,

    Buttonhighlight,

    Buttonshadow,

    Buttontext,

    Canvas,

    Canvastext,

    Capitalize,

    Captiontext,

    Cell,

    Center,

    Checkbox,

    Circle,

    Clip,

    CloseQuote,

    Coarse,

    ColResize,

    Collapse,

    Color,

    ColorDodge,

    ColorBurn,

    Column,

    ColumnReverse,

    CommonLigatures,

    Compact,

    Condensed,

    Contain,

    Content,

    ContentBox,

    Contents,

    ContextMenu,

    Contextual,

    Copy,

    Cover,

    CrispEdges,

    Crosshair,

    Currentcolor,

    Cursive,

    Custom,

    Dark,

    Darken,

    Dashed,

    Decimal,

    DecimalLeadingZero,

    Default,

    DiagonalFractions,

    Difference,

    Disc,

    DiscretionaryLigatures,

    DisclosureClosed,

    DisclosureOpen,

    Distribute,

    Dotted,

    Double,

    Down,

    EResize,

    Ease,

    EaseIn,

    EaseInOut,

    EaseOut,

    Ellipsis,

    Embed,

    Emoji,

    Enabled,

    End,

    Evenodd,

    EwResize,

    Exclusion,

    Expanded,

    ExtraCondensed,

    ExtraExpanded,

    Fallback,

    Fantasy,

    Fast,

    Field,

    Fieldtext,

    Fill,

    FillBox,

    Fine,

    FitContent,

    Fixed,

    Flex,

    FlexEnd,

    FlexStart,

    Flow,

    FlowRoot,

    Forwards,

    FromFont,

    FullSizeKana,

    FullWidth,

    Fullscreen,

    Grab,

    Grabbing,

    Graytext,

    Grid,

    Groove,

    HardLight,

    Help,

    Hidden,

    High,

    HighQuality,

    Highlight,

    Highlighttext,

    HistoricalForms,

    HistoricalLigatures,

    HorizontalTb,

    Hover,

    Hue,

    Inactiveborder,

    Inactivecaption,

    Inactivecaptiontext,

    Infinite,

    Infobackground,

    Infotext,

    Inherit,

    Initial,

    InitialOnly,

    Inline,

    InlineBlock,

    InlineEnd,

    InlineFlex,

    InlineGrid,

    InlineSize,

    InlineStart,

    InlineTable,

    Inset,

    Inside,

    InterCharacter,

    InterWord,

    Interlace,

    Invert,

    Inverted,

    Isolate,

    IsolateOverride,

    Italic,

    Jis04,

    Jis78,

    Jis83,

    Jis90,

    JumpBoth,

    JumpEnd,

    JumpNone,

    JumpStart,

    Justify,

    KeepAll,

    Landscape,

    Large,

    Larger,

    Layout,

    Left,

    Legacy,

    Less,

    Light,

    Lighter,

    Lighten,

    LineThrough,

    Linear,

    LiningNums,

    Linktext,

    ListItem,

    Listbox,

    Local,

    LowerAlpha,

    LowerLatin,

    LowerRoman,

    Lowercase,

    Ltr,

    Luminance,

    Luminosity,

    Mark,

    Marktext,

    MatchParent,

    Math,

    MathAuto,

    MaxContent,

    Medium,

    Menu,

    Menulist,

    MenulistButton,

    Menutext,

    Meter,

    Middle,

    MinContent,

    MinimalUi,

    Miter,

    Monospace,

    More,

    Move,

    Multiply,

    NResize,

    NeResize,

    Nearest,

    NeswResize,

    NoCloseQuote,

    NoCommonLigatures,

    NoContextual,

    NoDiscretionaryLigatures,

    NoDrop,

    NoHistoricalLigatures,

    NoOpenQuote,

    NoPreference,

    NoRepeat,

    None,

    Nonzero,

    Normal,

    NotAllowed,

    Nowrap,

    NsResize,

    NwResize,

    NwseResize,

    Oblique,

    Off,

    OldstyleNums,

    On,

    Opaque,

    OpenQuote,

    Optimizequality,

    Optimizespeed,

    Optional,

    Ordinal,

    Outset,

    Outside,

    Overlay,

    Overline,

    P3,

    PaddingBox,

    Paged,

    Paint,

    Paused,

    PetiteCaps,

    Pixelated,

    Plaintext,

    PlusDarker,

    PlusLighter,

    Pointer,

    Portrait,

    Pre,

    PreLine,

    PreWrap,

    Progress,

    ProgressBar,

    Progressive,

    ProportionalNums,

    ProportionalWidth,

    PushButton,

    Radio,

    Rec2020,

    Reduce,

    Relative,

    Repeat,

    RepeatX,

    RepeatY,

    Reverse,

    Revert,

    RevertLayer,

    Ridge,

    Right,

    Round,

    Row,

    RowResize,

    RowReverse,

    Rtl,

    Ruby,

    RubyBase,

    RubyBaseContainer,

    RubyText,

    RubyTextContainer,

    RunIn,

    Running,

    SResize,

    Safe,

    SansSerif,

    Saturation,

    ScaleDown,

    Screen,

    Scroll,

    Scrollbar,

    SeResize,

    Searchfield,

    Selecteditem,

    Selecteditemtext,

    SelfEnd,

    SelfStart,

    SemiCondensed,

    SemiExpanded,

    Separate,

    Serif,

    SidewaysLr,

    SidewaysRl,

    Simplified,

    Size,

    SlashedZero,

    SliderHorizontal,

    Slow,

    Small,

    SmallCaps,

    Smaller,

    Smooth,

    SoftLight,

    Solid,

    Space,

    SpaceAround,

    SpaceBetween,

    SpaceEvenly,

    Square,

    SquareButton,

    Srgb,

    Stable,

    StackedFractions,

    Standalone,

    Standard,

    Start,

    Static,

    Sticky,

    Stretch,

    Strict,

    StrokeBox,

    Style,

    Sub,

    Subtractive,

    Super,

    SwResize,

    Swap,

    Table,

    TableCaption,

    TableCell,

    TableColumn,

    TableColumnGroup,

    TableFooterGroup,

    TableHeaderGroup,

    TableRow,

    TableRowGroup,

    TabularNums,

    Text,

    TextBottom,

    TextTop,

    Textarea,

    Textfield,

    Thick,

    Thin,

    TitlingCaps,

    Threeddarkshadow,

    Threedface,

    Threedhighlight,

    Threedlightshadow,

    Threedshadow,

    ToZero,

    Top,

    Traditional,

    UiMonospace,

    UiRounded,

    UiSansSerif,

    UiSerif,

    UltraCondensed,

    UltraExpanded,

    Underline,

    Unicase,

    Unicode,

    Unsafe,

    Unset,

    Up,

    UpperAlpha,

    UpperLatin,

    UpperRoman,

    Uppercase,

    VerticalLr,

    VerticalRl,

    VerticalText,

    ViewBox,

    Visible,

    Visitedtext,

    WResize,

    Wait,

    Wavy,

    Window,

    Windowframe,

    Windowtext,

    Wrap,

    WrapReverse,

    XLarge,

    XSmall,

    XxLarge,

    XxSmall,

    XxxLarge,

    ZoomIn,

    ZoomOut,

};

Optional<Keyword> keyword_from_string(StringView);
StringView string_from_keyword(Keyword);

// https://www.w3.org/TR/css-values-4/#common-keywords
// https://drafts.csswg.org/css-cascade-4/#valdef-all-revert
inline bool is_css_wide_keyword(StringView name)
{
    return name.equals_ignoring_ascii_case("inherit"sv)
        || name.equals_ignoring_ascii_case("initial"sv)
        || name.equals_ignoring_ascii_case("revert"sv)
        || name.equals_ignoring_ascii_case("revert-layer"sv)
        || name.equals_ignoring_ascii_case("unset"sv);
}

}

