
#pragma once

#include <AK/Optional.h>
#include <AK/StringView.h>

namespace Web::CSS {

enum class PseudoClass {
    Active,
    AnyLink,
    Buffering,
    Checked,
    Defined,
    Dir,
    Disabled,
    Empty,
    Enabled,
    FirstChild,
    FirstOfType,
    Focus,
    FocusVisible,
    FocusWithin,
    Has,
    Host,
    Hover,
    Indeterminate,
    Invalid,
    Is,
    Lang,
    LastChild,
    LastOfType,
    Link,
    LocalLink,
    Modal,
    Muted,
    Not,
    NthChild,
    NthLastChild,
    NthLastOfType,
    NthOfType,
    OnlyChild,
    OnlyOfType,
    Open,
    PopoverOpen,
    Paused,
    PlaceholderShown,
    Playing,
    ReadOnly,
    ReadWrite,
    Root,
    Scope,
    Seeking,
    Stalled,
    Target,
    TargetWithin,
    UserInvalid,
    UserValid,
    Valid,
    Visited,
    VolumeLocked,
    Where,

};

Optional<PseudoClass> pseudo_class_from_string(StringView);
StringView pseudo_class_name(PseudoClass);

struct PseudoClassMetadata {
    enum class ParameterType {
        None,
        ANPlusB,
        ANPlusBOf,
        CompoundSelector,
        ForgivingSelectorList,
        ForgivingRelativeSelectorList,
        Ident,
        LanguageRanges,
        RelativeSelectorList,
        SelectorList,
    } parameter_type;
    bool is_valid_as_function;
    bool is_valid_as_identifier;
};
PseudoClassMetadata pseudo_class_metadata(PseudoClass);

}
